package dev.shadowsoffire.apotheosis.adventure.socket;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.google.common.base.Predicates;
import com.google.common.collect.ImmutableList;
import com.google.common.collect.UnmodifiableIterator;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.stream.DoubleStream;
import java.util.stream.Stream;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.MobType;
import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.context.UseOnContext;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.storage.loot.LootContext;

public final class SocketedGems extends Record implements List<GemInstance> {
  private final ImmutableList<GemInstance> gems;
  
  public SocketedGems(ImmutableList<GemInstance> gems) {
    this.gems = gems;
  }
  
  public final String toString() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> toString : (Ldev/shadowsoffire/apotheosis/adventure/socket/SocketedGems;)Ljava/lang/String;
    //   6: areturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #43	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/socket/SocketedGems;
  }
  
  public final int hashCode() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> hashCode : (Ldev/shadowsoffire/apotheosis/adventure/socket/SocketedGems;)I
    //   6: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #43	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/socket/SocketedGems;
  }
  
  public final boolean equals(Object o) {
    // Byte code:
    //   0: aload_0
    //   1: aload_1
    //   2: <illegal opcode> equals : (Ldev/shadowsoffire/apotheosis/adventure/socket/SocketedGems;Ljava/lang/Object;)Z
    //   7: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #43	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	8	0	this	Ldev/shadowsoffire/apotheosis/adventure/socket/SocketedGems;
    //   0	8	1	o	Ljava/lang/Object;
  }
  
  public ImmutableList<GemInstance> gems() {
    return this.gems;
  }
  
  public static final dev.shadowsoffire.apotheosis.adventure.socket.SocketedGems EMPTY = new dev.shadowsoffire.apotheosis.adventure.socket.SocketedGems(ImmutableList.of());
  
  public SocketedGems(List<GemInstance> gems) {
    this(ImmutableList.copyOf(gems));
  }
  
  public void addModifiers(LootCategory cat, EquipmentSlot type, BiConsumer<Attribute, AttributeModifier> map) {
    streamValidGems().forEach(inst -> inst.addModifiers(type, map));
  }
  
  public int getDamageProtection(DamageSource source) {
    return ((Integer)streamValidGems().<Integer>map(inst -> Integer.valueOf(inst.getDamageProtection(source))).reduce(Integer.valueOf(0), Integer::sum)).intValue();
  }
  
  public float getDamageBonus(MobType creatureType) {
    return ((Float)streamValidGems().<Float>map(inst -> Float.valueOf(inst.getDamageBonus(creatureType))).reduce(Float::sum).orElse(Float.valueOf(0.0F))).floatValue();
  }
  
  public void doPostAttack(LivingEntity user, Entity target) {
    streamValidGems().forEach(inst -> {
          int old = target.f_19802_;
          target.f_19802_ = 0;
          inst.doPostAttack(user, target);
          target.f_19802_ = old;
        });
  }
  
  public void doPostHurt(LivingEntity user, Entity attacker) {
    streamValidGems().forEach(inst -> inst.doPostHurt(user, attacker));
  }
  
  public void onArrowFired(LivingEntity user, AbstractArrow arrow) {
    streamValidGems().forEach(inst -> inst.onArrowFired(user, arrow));
  }
  
  @Nullable
  public InteractionResult onItemUse(UseOnContext useinst) {
    return streamValidGems().<InteractionResult>map(inst -> inst.onItemUse(useinst)).filter(Predicates.notNull()).findFirst().orElse(null);
  }
  
  public float onShieldBlock(LivingEntity entity, DamageSource source, float amount) {
    for (UnmodifiableIterator<GemInstance> unmodifiableIterator = this.gems.iterator(); unmodifiableIterator.hasNext(); ) {
      GemInstance inst = unmodifiableIterator.next();
      if (inst.isValid())
        amount = inst.onShieldBlock(entity, source, amount); 
    } 
    return amount;
  }
  
  public void onBlockBreak(Player player, LevelAccessor world, BlockPos pos, BlockState state) {
    streamValidGems().forEach(inst -> inst.onBlockBreak(player, world, pos, state));
  }
  
  public DoubleStream getDurabilityBonusPercentage(ServerPlayer user) {
    return streamValidGems().mapToDouble(inst -> inst.getDurabilityBonusPercentage(user));
  }
  
  public float onHurt(DamageSource src, LivingEntity ent, float amount) {
    for (UnmodifiableIterator<GemInstance> unmodifiableIterator = this.gems.iterator(); unmodifiableIterator.hasNext(); ) {
      GemInstance inst = unmodifiableIterator.next();
      if (inst.isValid())
        amount = inst.onHurt(src, ent, amount); 
    } 
    return amount;
  }
  
  public void getEnchantmentLevels(Map<Enchantment, Integer> enchantments) {
    streamValidGems().forEach(inst -> inst.getEnchantmentLevels(enchantments));
  }
  
  public void modifyLoot(ObjectArrayList<ItemStack> loot, LootContext ctx) {
    streamValidGems().forEach(inst -> inst.modifyLoot(loot, ctx));
  }
  
  public Stream<GemInstance> streamValidGems() {
    return this.gems.stream().filter(GemInstance::isValid);
  }
  
  public int size() {
    return this.gems.size();
  }
  
  public boolean isEmpty() {
    return this.gems.isEmpty();
  }
  
  public boolean contains(Object o) {
    return this.gems.contains(o);
  }
  
  public Iterator<GemInstance> iterator() {
    return this.gems.iterator();
  }
  
  public Object[] toArray() {
    return this.gems.toArray();
  }
  
  public <T> T[] toArray(T[] a) {
    return (T[])this.gems.toArray((Object[])a);
  }
  
  @Deprecated
  public boolean add(GemInstance e) {
    throw new UnsupportedOperationException();
  }
  
  @Deprecated
  public boolean remove(Object o) {
    throw new UnsupportedOperationException();
  }
  
  public boolean containsAll(Collection<?> c) {
    return this.gems.containsAll(c);
  }
  
  @Deprecated
  public boolean addAll(Collection<? extends GemInstance> c) {
    throw new UnsupportedOperationException();
  }
  
  @Deprecated
  public boolean addAll(int index, Collection<? extends GemInstance> c) {
    throw new UnsupportedOperationException();
  }
  
  public boolean removeAll(Collection<?> c) {
    return false;
  }
  
  @Deprecated
  public boolean retainAll(Collection<?> c) {
    throw new UnsupportedOperationException();
  }
  
  @Deprecated
  public void clear() {
    throw new UnsupportedOperationException();
  }
  
  public GemInstance get(int index) {
    return this.gems.get(index);
  }
  
  @Deprecated
  public GemInstance set(int index, GemInstance element) {
    throw new UnsupportedOperationException();
  }
  
  @Deprecated
  public void add(int index, GemInstance element) {
    throw new UnsupportedOperationException();
  }
  
  @Deprecated
  public GemInstance remove(int index) {
    throw new UnsupportedOperationException();
  }
  
  public int indexOf(Object o) {
    return this.gems.indexOf(o);
  }
  
  public int lastIndexOf(Object o) {
    return this.gems.lastIndexOf(o);
  }
  
  public ListIterator<GemInstance> listIterator() {
    return this.gems.listIterator();
  }
  
  public ListIterator<GemInstance> listIterator(int index) {
    return this.gems.listIterator(index);
  }
  
  public List<GemInstance> subList(int fromIndex, int toIndex) {
    return this.gems.subList(fromIndex, toIndex);
  }
}
